// infobar.h				emacs, this is written in -*-c++-*-
//
// This program is free software. See the file COPYING for details.
// Author: Mattias Engdegrd, 1997-1999

#ifndef INFOBAR_H
#define INFOBAR_H

#include <qpainter.h>
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qstring.h>
#include <qpixmap.h>
#include <QResizeEvent>
#include <QFrame>
#include <QEvent>
#include <QMouseEvent>
#include "misc.h"


class CPUbar : public QWidget
{
    Q_OBJECT
public:
    CPUbar(QWidget *parent);
    void refresh();
 //   void update_load();
 //   void show_and_hide(bool, QWidget *, QWidget *);
//signals:  void config_change();
protected:
	void paintEvent ( QPaintEvent * );
	void mousePressEvent(QMouseEvent *);
private:
//	List<gwidget*>  wlist;
//    QPixmap pm;
	QWidget *parent;
    bool is_vertical;
};

class gwidget {
	public:
		gwidget(){x=0,y=0,width=0,height=0;		};
		gwidget(QWidget *p){parent=p;};
		virtual void draw(QPainter *p){printf("gwidget\n");};
		virtual void setPosition(int parent_width,int parent_height){};
		virtual char *info(){ return NULL; };
		void setParent(QWidget *p){parent=p;};
		void resize(int x_,int y_,int w,int h)
		{ x=x_;y=y_;width=w;height=h;};
		bool  intersect(int cx,int cy)
		{	
			cx = cx - x;
			cy = cy - y;
			if ( cx > 0 and cx < width)
				if ( cy > 0 and cy < height)
					return true;
			return false;
		}


		int  xpluswidth(){return x+width;};
	protected:
		int x;
		int y;
		int width;
		int height;
		QRect rect;
		QWidget *parent;
};




class LoadGraph2 : public QFrame
{
    Q_OBJECT
public:
    LoadGraph2(QWidget *parent, int history_size);
    ~LoadGraph2();

    void add_load_point();	// add current load as a data point
    void configure();		// respond to configuration change

    QPixmap *make_icon(int w, int h);

signals:
    void clicked();

protected:
    void paintEvent ( QPaintEvent * );
    void mousePressEvent(QMouseEvent *);
    void mouseMoveEvent(QMouseEvent *);
    void leaveEvent ( QEvent * );

    void add_history_point(unsigned value);
    void make_graph2(int w, int h);
    void make_graph(int w, int h, QPainter *p);
    void add_history_point2(float value);
private:
    
	List<gwidget*>  wlist;
    int hist_size;	// history buffer size
    int npoints;		// nr of history points currently remembered
    // history points are stored in fixed point, scaled by history_scale
    static const unsigned history_scale = 256;
    static const int time_dist = 60; // time between vertical lines (seconds)
    float *history;		// (circular) history buffer
    float peak;		// largest value in history
    int h_index;		// next history index to use
   
    bool dirty;			// history changed since pixmap was drawn
    QPixmap pm;
    QPixmap icon_pm;


};

class Infobar : public LoadGraph2
{
    Q_OBJECT
public:
    Infobar(QWidget *parent);
    void refresh();
    void update_load();
    QPixmap *load_icon(int w, int h) { return make_icon(w, h); }
    bool swaplim_exceeded();
    void show_and_hide(bool, QWidget *, QWidget *);
    void showup();
	void hideEvent ( QHideEvent * event );
signals:
    void config_change();
private:
   // LoadGraph2 *load_graph;
    bool is_vertical;
};


#endif	// INFOBAR_H
